## broker 1.2.5+ds1

=== debian/changelog ===
broker (1.2.5+ds1-1) unstable; urgency=medium

  * New upstream version 1.2.5+ds1
  * Drop RocksDB build-dependency
  * Make library, -dev package multi-arch.
  * Rebase patches

 -- Hilko Bengen <bengen@debian.org>  Thu, 27 Feb 2020 16:39:24 +0100

broker (1.2.4+ds1-1) unstable; urgency=medium

  * New upstream version 1.2.4+ds1
  * Add missint dh-python build-dependency
  * Adjust library name for SONAME change

 -- Hilko Bengen <bengen@debian.org>  Sat, 21 Dec 2019 18:42:36 +0100

broker (1.1.2+ds1-2) unstable; urgency=medium

  * Fix multiple issues in debian/copyright

 -- Hilko Bengen <bengen@debian.org>  Mon, 02 Sep 2019 12:04:39 +0200

broker (1.1.2+ds1-1) unstable; urgency=low

  * Initial release (Closes: #921561)

 -- Hilko Bengen <bengen@debian.org>  Thu, 07 Feb 2019 07:01:23 +0100
