=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --with=python3

# override_dh_auto_test:

override_dh_auto_configure:
	dh_auto_configure -- \
	-DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	-DCAF_ROOT_DIR=/usr/include \
	-DBINARY_PACKAGING_MODE=1 \
	-DBROKER_VERSION=$(shell dpkg-parsechangelog --show-field Version | sed -E -e 's/([0-9]+[.][0-9]+).*/\1/')

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

override_dh_missing:
	dh_missing --fail-missing

override_dh_dwz:
	dh_dwz -X/usr/lib/python3/
