=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/,dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/$/+ds1/ \
    https://www.bro.org/downloads/ broker-(\d.*)\.tar\.gz
