## broker 1.2.8+ds1

=== debian/changelog ===
broker (1.2.8+ds1-1) unstable; urgency=medium

  * New upstream version 1.2.8+ds1

 -- Hilko Bengen <bengen@debian.org>  Sun, 31 May 2020 14:04:55 +0200

broker (1.2.5+ds1-3) unstable; urgency=medium

  * Update watch file
  * Fix test failure with Python 3.8 looking for the ssl module in
    the wrong place

 -- Hilko Bengen <bengen@debian.org>  Sat, 30 May 2020 19:50:25 +0200

broker (1.2.5+ds1-2) unstable; urgency=medium

  * Update swig build-dependency (Closes: #956948)

 -- Hilko Bengen <bengen@debian.org>  Sat, 30 May 2020 15:21:37 +0200
