=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/,dversionmangle=s/\+dfsg\d*$//,uversionmangle=s/$/+ds1/ \
    https://download.zeek.org/ broker-(\d.*)\.tar\.gz
