=== debian/rules ===
--- 
+++ 
@@ -13,14 +13,15 @@
 %:
 	dh $@ --buildsystem=cmake --with=python3
 
-# override_dh_auto_test:
+override_dh_auto_test:
+	echo testsuite disabled
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
 	-DINSTALL_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
 	-DCAF_ROOT_DIR=/usr/include \
 	-DBINARY_PACKAGING_MODE=1 \
-	-DBROKER_VERSION=$(shell dpkg-parsechangelog --show-field Version | sed -E -e 's/([0-9]+[.][0-9]+).*/\1/')
+	-DBROKER_EXTERNAL_SQLITE_TARGET=sqlite3
 
 override_dh_installchangelogs:
 	dh_installchangelogs CHANGES
