=== docs/requirements.txt ===
# Python dependencies for building the docs
Sphinx
sphinx_rtd_theme

# The reason this file is in docs/ instead of doc/ is a workaround for Read
# the Docs trying to automatically locate a requirements.txt, ignoring paths
# that were explicitly supplied via the admin settings for RtD project.

# It happens that pybind11 has it's own docs/requirements.txt, which becomes
# the relative path that RtD will unconditionally try to look for in broker.

# It generally looks like any number of requirements.txt or conf.py files
# found in the directory tree may cause RtD to incorrectly use the wrong
# one, even overriding your explicit settings for their location.  So
# this workaround may not even be completely stable going forward.
