=== debian/changelog ===
broker (1.4.0+ds1-1) unstable; urgency=medium

  * New upstream version 1.4.0+ds1
  * Update watch file
  * Add git-buildpackage configuration
  * Drop/ignore caf/ (vendored actor-framework sources) from upstream tarball
  * Update patches, build script

 -- Hilko Bengen <bengen@debian.org>  Fri, 25 Dec 2020 23:16:06 +0100
