=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libcaf-dev (>= 0.16),
  libsqlite3-dev,
  python3-dev,
- swig3.0,
+ swig,
  libssl-dev,
  pybind11-dev,
 Standards-Version: 4.3.0
