=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,7 @@
 %:
 	dh $@ --buildsystem=cmake --with=python3
 
-override_dh_auto_test:
-	echo testsuite disabled
+# override_dh_auto_test:
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
