=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%broker-$1.tar.gz%,dversionmangle=s/\+ds\d*$//,uversionmangle=s/$/+ds1/" \
   https://github.com/zeek/broker/releases \
   (?:.*?/)broker-(\d[\d.]*)\.tar\.gz debian uupdate
