=== bindings/python/CMakeLists.txt ===
--- 
+++ 
@@ -31,16 +31,16 @@
                            ${PYTHON_INCLUDE_DIRS})
 
 # Set libraries to link against.
-target_compile_options(_broker PRIVATE "-fvisibility=hidden")
+if (NOT WIN32)
+  target_compile_options(_broker PRIVATE "-fvisibility=hidden")
+endif ()
+
 if (ENABLE_SHARED)
   set(libbroker broker)
 else ()
   set(libbroker broker_static)
 endif ()
 target_link_libraries(_broker PUBLIC ${libbroker} ${PYTHON_LIBRARIES})
-if (ROCKSDB_FOUND)
-  target_link_libraries(_broker PUBLIC ${ROCKSDB_LIBRARIES})
-endif ()
 if (APPLE)
   # Support multiple Python installations.
   target_link_libraries(_broker PRIVATE "-undefined dynamic_lookup")
@@ -70,16 +70,15 @@
   # Figure out Python module install directory.
   if (BROKER_PYTHON_PREFIX)
     set(pyver ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR})
-    set(PY_MOD_INSTALL_DIR
-        ${BROKER_PYTHON_PREFIX}/lib/python${pyver}/site-packages)
+    file(TO_CMAKE_PATH "${BROKER_PYTHON_PREFIX}/lib/python${pyver}/site-packages" PY_MOD_INSTALL_DIR)
   elseif (BROKER_PYTHON_HOME)
-    set(PY_MOD_INSTALL_DIR ${BROKER_PYTHON_HOME}/lib/python)
+    file(TO_CMAKE_PATH "${BROKER_PYTHON_HOME}/lib/python" PY_MOD_INSTALL_DIR)
   else ()
     execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
       "from distutils.sysconfig import get_python_lib; print(get_python_lib())"
       OUTPUT_VARIABLE python_site_packages
       OUTPUT_STRIP_TRAILING_WHITESPACE)
-    set(PY_MOD_INSTALL_DIR ${python_site_packages})
+    file(TO_CMAKE_PATH ${python_site_packages} PY_MOD_INSTALL_DIR)
   endif ()
 endif ()
 message(STATUS "Python bindings will be built and installed to:")
