=== debian/changelog ===
broker (2.6.0-0kali1) kali-experimental; urgency=medium

  * New upstream version 2.6.0
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 27 Jun 2024 16:10:44 +0200
